/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package businessLogic;

import entities.Book;
import entities.Chapter;
import facades.local.BookFacadeLocal;
import java.util.ArrayList;
import java.util.List;
import javax.ejb.EJB;
import javax.ejb.Stateless;

/**
 *
 * @author Burabari
 */
@Stateless
public class Book_mgt implements Book_mgtRemote {
    @EJB
    BookFacadeLocal bookFAC;
    
    @Override
    public void persistBook(String bookTitle, ArrayList<String> chapters){
        List<Chapter> listOfChapters = null;
        if(chapters != null && !chapters.isEmpty()){
            listOfChapters = new ArrayList<Chapter>();
            for(String ch_title : chapters){
                Chapter ch = new Chapter();
                ch.setChapterTitle(ch_title);
                listOfChapters.add(ch);
            }
        }
        
        Book book = new Book();
        book.setBookTitle(bookTitle);
        if(listOfChapters != null){
            book.setChapters(listOfChapters);
        }
        
        bookFAC.create(book);
    }
    
    @Override
    public void addBookChapters(String bookTitle, ArrayList<String> new_chapters){
        Book book = bookFAC.findBookByTitle(bookTitle);
        List<Chapter> listOfNewChapters = null;
        if(new_chapters != null && !new_chapters.isEmpty()){
            listOfNewChapters = new ArrayList<Chapter>();
            for(String ch_title : new_chapters){
                Chapter ch = new Chapter();
                ch.setChapterTitle(ch_title);
                listOfNewChapters.add(ch);
            }
        }
        
        if(listOfNewChapters != null){
            if(book.getChapters() == null){
                book.setChapters(listOfNewChapters);
            }else{
                book.getChapters().addAll(listOfNewChapters);
            }
        }
        
    }
    
}
